import { j as f } from "../../node_modules/react/jsx-runtime.mjs";
import { useRef as h, useCallback as D, useMemo as k } from "react";
import { clsx as d } from "../../node_modules/clsx/dist/clsx.mjs";
import { preventDefault as z, getScrollTop as P } from "../../utils/scroll.mjs";
import { getScrollParent as Y } from "../../hooks/use-scroll-parent.mjs";
import w from "../../hooks/use-event-listener.mjs";
import A from "../../node_modules/ahooks/es/useSetState/index.mjs";
import M from "../../node_modules/ahooks/es/useUpdateEffect/index.mjs";
import U from "../../hooks/use-touch.mjs";
import { mergeProps as C } from "../../utils/get-default-props.mjs";
const L = 50, F = ["pulling", "loosing", "success"], G = {
  pulling: "下拉即可刷新...",
  loosing: "释放即可刷新...",
  loading: "加载中..."
}, Z = (v) => {
  const e = C(v, {
    headHeight: 50,
    animationDuration: 300,
    successDuration: 500
  }), { disabled: m, animationDuration: g } = e, H = h(null), [s, n] = A({
    refreshing: !1,
    status: "normal",
    distance: 0,
    duration: 0
  }), p = h(null), i = h(null), o = U(), _ = () => {
    if (e.headHeight !== L)
      return {
        height: `${e.headHeight}px`
      };
  }, l = D(() => s.status !== "loading" && s.status !== "success" && !m, [s.status, m]), y = (t) => {
    const r = +(e.pullDistance || e.headHeight);
    return t > r && (t < r * 2 ? t = r + (t - r) / 2 : t = r * 1.5 + (t - r * 2) / 4), Math.round(t);
  }, u = (t, r) => {
    const c = +(e.pullDistance || e.headHeight), a = { distance: t };
    r ? a.status = "loading" : t === 0 ? a.status = "normal" : t < c ? a.status = "pulling" : a.status = "loosing", n(a);
  }, T = () => s.status === "normal" ? "" : e[`${s.status}Text`] || G[s.status], E = () => {
    var a;
    const { status: t, distance: r } = s;
    if (typeof e[`${s.status}Text`] == "function")
      return (a = e[`${s.status}Text`]) == null ? void 0 : a.call(e, { distance: r });
    const c = [];
    return F.includes(t) && c.push(
      /* @__PURE__ */ f.jsx("div", { className: "bitz-pull-refresh__text", children: T() }, "text")
    ), t === "loading" && c.push(
      /* @__PURE__ */ f.jsx("div", { className: "bitz-pull-refresh__loading", children: T() })
    ), c;
  }, b = () => {
    n({ status: "success" }), setTimeout(() => {
      u(0);
    }, +e.successDuration);
  }, j = async () => {
    try {
      n({ refreshing: !0 }), await e.onRefresh(), n({ refreshing: !1 });
    } catch {
      n({ refreshing: !1 });
    }
  }, x = (t) => {
    const r = Y(t.target);
    i.current = P(r) === 0, i.current && (n({ duration: 0 }), o.start(t));
  }, R = (t) => {
    l() && x(t.nativeEvent);
  }, N = D(
    (t) => {
      l() && (i.current || x(t), o.move(t), i.current && o.deltaY.current >= 0 && o.isVertical() ? (u(y(o.deltaY.current)), z(t)) : u(0));
    },
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [i.current, o.deltaY.current, l]
  ), S = async () => {
    i.current && o.deltaY && l() && (n({ duration: +g }), s.status === "loosing" ? (u(+e.headHeight, !0), await j(), setTimeout(() => {
      var t;
      return (t = e.onRefreshEnd) == null ? void 0 : t.call(e);
    })) : u(0));
  };
  w("touchmove", N, {
    target: p.current,
    depends: [i.current, l(), o.deltaY]
  }), M(() => {
    n({ duration: +g }), s.refreshing ? u(+e.headHeight, !0) : e.successText ? b() : u(0, !1);
  }, [s.refreshing]);
  const $ = k(
    () => ({
      transitionDuration: `${s.duration}ms`,
      transform: s.distance ? `translate3d(0,${s.distance}px, 0)` : ""
    }),
    [s.duration, s.distance]
  );
  return /* @__PURE__ */ f.jsx(
    "div",
    {
      ref: H,
      className: d(e.className, "bitz-pull-refresh"),
      style: e.style,
      children: /* @__PURE__ */ f.jsxs(
        "div",
        {
          ref: p,
          className: d("bitz-pull-refresh__track"),
          style: $,
          onTouchStart: R,
          onTouchEnd: S,
          onTouchCancel: S,
          children: [
            /* @__PURE__ */ f.jsx("div", { className: d("bitz-pull-refresh__head"), style: _(), children: E() }),
            e.children
          ]
        }
      )
    }
  );
};
export {
  Z as default
};
