import { j as R } from "../../../node_modules/react/jsx-runtime.mjs";
import j from "../../../hooks/useMergedState.mjs";
import { createContext as k, useRef as J, useMemo as U, useEffect as N, useCallback as q } from "react";
import { genColumnKey as A } from "./utils/index.mjs";
import { getUuid as B } from "../../../utils/uuid.mjs";
import d from "../../../node_modules/lodash-es/merge.mjs";
function D(e = {}) {
  var K, g, V, T, M, v, O, b, x;
  const f = J(B()), y = J([]), { defaultSize: I = "lg" } = e, [P, E] = j(
    () => e.size ?? I,
    {
      value: e.size,
      onChange: e.onSizeChange
    }
  ), r = U(() => {
    var u, n;
    if ((u = e == null ? void 0 : e.columnsState) != null && u.defaultValue)
      return e.columnsState.defaultValue;
    const t = {};
    return (n = e.columns) == null || n.forEach(({ key: i, dataIndex: m, fixed: o, disable: a }, l) => {
      const c = A(i ?? m, l);
      c && (t[c] = {
        show: !0,
        fixed: o,
        disable: a
      });
    }), t;
  }, [e.columns]), [w, S] = j(
    () => {
      var i, m, o, a, l;
      const { persistenceType: t, persistenceKey: u, onlineGet: n } = e.columnsState || {};
      if (u && t && typeof window < "u")
        if (t !== "online") {
          const c = window[t];
          try {
            const s = c == null ? void 0 : c.getItem(u);
            if (s)
              return (i = e == null ? void 0 : e.columnsState) != null && i.defaultValue ? d(
                JSON.parse(s),
                (m = e == null ? void 0 : e.columnsState) == null ? void 0 : m.defaultValue
              ) : JSON.parse(s);
          } catch (s) {
            console.warn(s);
          }
        } else
          try {
            (o = n == null ? void 0 : n(u)) == null || o.then((c) => {
              var s, z;
              if (c)
                return (s = e == null ? void 0 : e.columnsState) != null && s.defaultValue ? d(c, (z = e == null ? void 0 : e.columnsState) == null ? void 0 : z.defaultValue) : c;
            });
          } catch (c) {
            console.warn(c);
          }
      return e.columnsStateMap || ((a = e.columnsState) == null ? void 0 : a.value) || ((l = e.columnsState) == null ? void 0 : l.defaultValue) || r;
    },
    {
      value: ((K = e.columnsState) == null ? void 0 : K.value) || e.columnsStateMap,
      onChange: ((g = e.columnsState) == null ? void 0 : g.onChange) || e.onColumnsStateChange
    }
  );
  N(() => {
    var i, m, o;
    const { persistenceType: t, persistenceKey: u, onlineGet: n } = e.columnsState || {};
    if (u && t && typeof window < "u")
      if (t !== "online") {
        const a = window[t];
        try {
          const l = a == null ? void 0 : a.getItem(u);
          l ? (i = e == null ? void 0 : e.columnsState) != null && i.defaultValue ? S(
            d(
              JSON.parse(l),
              (m = e == null ? void 0 : e.columnsState) == null ? void 0 : m.defaultValue
            )
          ) : S(JSON.parse(l)) : S(r);
        } catch (l) {
          console.warn(l);
        }
      } else
        try {
          (o = n == null ? void 0 : n(u)) == null || o.then((a) => {
            var l, c;
            if (a)
              return (l = e == null ? void 0 : e.columnsState) != null && l.defaultValue ? d(a, (c = e == null ? void 0 : e.columnsState) == null ? void 0 : c.defaultValue) : a;
          });
        } catch (a) {
          console.warn(a);
        }
  }, [
    (V = e.columnsState) == null ? void 0 : V.persistenceKey,
    (T = e.columnsState) == null ? void 0 : T.persistenceType,
    r
  ]);
  const h = q(() => {
    const { persistenceType: t, persistenceKey: u } = e.columnsState || {};
    if (!u || !t || typeof window > "u")
      return;
    const n = window[t];
    try {
      n == null || n.removeItem(u);
    } catch (i) {
      console.warn(i);
    }
  }, [e.columnsState]);
  N(() => {
    var n, i;
    if (!((n = e.columnsState) != null && n.persistenceKey) || !((i = e.columnsState) != null && i.persistenceType) || typeof window > "u")
      return;
    const {
      persistenceType: t,
      persistenceKey: u
      // onlineChange
    } = e.columnsState;
    if (t !== "online") {
      const m = window[t];
      try {
        m == null || m.setItem(u, JSON.stringify(w));
      } catch (o) {
        console.warn(o), h();
      }
    }
  }, [
    (M = e.columnsState) == null ? void 0 : M.persistenceKey,
    w,
    (v = e.columnsState) == null ? void 0 : v.persistenceType
  ]);
  const C = {
    uuid: f.current,
    persistenceType: (O = e.columnsState) == null ? void 0 : O.persistenceType,
    persistenceKey: (b = e.columnsState) == null ? void 0 : b.persistenceKey,
    onlineChange: (x = e.columnsState) == null ? void 0 : x.onlineChange,
    sortKeyColumns: y.current,
    setSortKeyColumns: (t) => {
      y.current = t;
    },
    columnsMap: w,
    setColumnsMap: S,
    setTableSize: E,
    tableSize: P,
    columns: e.columns,
    clearPersistenceStorage: h,
    defaultColumnKeyMap: r
  };
  return Object.defineProperty(C, "sortKeyColumns", {
    get: () => y.current
  }), Object.defineProperty(C, "uuid", {
    get: () => f.current
  }), C;
}
const F = k({}), Z = (e) => {
  const f = D(e.initValue);
  return /* @__PURE__ */ R.jsx(F.Provider, { value: f, children: e.children });
};
export {
  F as TableContext,
  Z as default
};
