import { j as o } from "../../../../node_modules/react/jsx-runtime.mjs";
import { create as U, useModal as X, antdModalV5 as Y } from "@ebay/nice-modal-react";
import { theme as Z, Modal as L, Checkbox as ee, Button as oe } from "antd";
import c from "./index.module.less.mjs";
import { useState as E, useContext as se, useEffect as te, useCallback as H, useMemo as y } from "react";
import { TableContext as le } from "../../Store/index.mjs";
import { genColumnKey as R, columnSort as ne } from "../../Store/utils/index.mjs";
import u from "../../../../node_modules/classnames/index.mjs";
import { DndContext as ce } from "../../../../node_modules/@dnd-kit/core/dist/core.esm.mjs";
import { SortableContext as ae, verticalListSortingStrategy as re, arrayMove as ie } from "../../../../node_modules/@dnd-kit/sortable/dist/sortable.esm.mjs";
import me from "./DndItem.mjs";
import { restrictToVerticalAxis as de, restrictToWindowEdges as ue } from "../../../../node_modules/@dnd-kit/modifiers/dist/modifiers.esm.mjs";
import z from "../../../BitzButton/index.mjs";
import { useImmer as pe } from "../../../../node_modules/use-immer/dist/use-immer.module.mjs";
import { css as he } from "../../../../node_modules/@emotion/css/dist/emotion-css.esm.mjs";
import "./index.less.mjs";
import A from "../../../../node_modules/lodash-es/omit.mjs";
import xe from "../../../../node_modules/@ant-design/icons/es/icons/CheckCircleOutlined.mjs";
import be from "../../../../node_modules/@ant-design/icons/es/icons/RedoOutlined.mjs";
const Re = U(() => {
  var D;
  const { token: p } = Z.useToken(), x = X(), [f, j] = E(null), [O, g] = E(!1), [a, b] = pe({
    columnsMap: {},
    sortKeyColumns: []
  }), {
    persistenceType: V,
    persistenceKey: N,
    onlineChange: M,
    columnsMap: F,
    setColumnsMap: P,
    sortKeyColumns: W,
    setSortKeyColumns: $,
    // clearPersistenceStorage,
    ...l
  } = se(le);
  te(() => {
    b((e) => {
      e.columnsMap = { ...F }, e.sortKeyColumns = [...W];
    });
  }, []);
  const q = H(() => {
    b((e) => {
      e.columnsMap = { ...l.defaultColumnKeyMap };
    });
  }, []), h = y(() => {
    var s, n;
    const e = [];
    return (s = l == null ? void 0 : l.columns) != null && s.length && ((n = l == null ? void 0 : l.columns) == null || n.map(({ key: d, dataIndex: t, ...i }) => {
      const C = R(
        d || t,
        [d || t].filter(Boolean).join("-")
      ), m = a.columnsMap[C || "null"];
      return (m == null ? void 0 : m.show) !== !1 && e.push({
        key: C,
        ...A(i, ["className"]),
        selectable: !1,
        disabled: (m == null ? void 0 : m.disable) === !0
      }), m;
    })), e.sort(ne(a.columnsMap));
  }, [a.columnsMap, l == null ? void 0 : l.columns]), k = H(
    (e) => {
      var s;
      return (s = a.sortKeyColumns) == null ? void 0 : s.findIndex((n) => n === e);
    },
    [a.sortKeyColumns]
  ), K = y(
    () => f ? k(f) : -1,
    [f, k]
  ), w = y(() => {
    const e = [], s = /* @__PURE__ */ new Map();
    return { list: ((d, t) => d.map(({ key: i, dataIndex: C, children: m, ...T }) => {
      var _;
      const S = R(
        i || C,
        [t == null ? void 0 : t.columnKey, T.index].filter(Boolean).join("-")
      ), r = a.columnsMap[S || "null"] || { show: !0 };
      (r == null ? void 0 : r.show) !== !1 && !m && e.push(S);
      const I = {
        key: S,
        ...A(T, ["className"]),
        selectable: !1,
        disabled: r.disable === !0,
        disableCheckbox: typeof r.disable == "boolean" ? r == null ? void 0 : r.disable : (_ = r == null ? void 0 : r.disable) == null ? void 0 : _.checkbox,
        isLeaf: t ? !0 : void 0
      };
      return s.set(i, I), I;
    }))(l == null ? void 0 : l.columns), keys: e, map: s };
  }, [a.columnsMap, l == null ? void 0 : l.columns]), G = (e, s) => {
    const n = { ...a.columnsMap };
    ((t) => {
      const i = { ...n[t] };
      i.show = !e, n[t] = i;
    })(s.key), g(!0), b((t) => {
      t.columnsMap = { ...n };
    });
  }, J = (e, s) => {
    const n = { ...a.columnsMap }, d = ie(a.sortKeyColumns, e, s);
    d.forEach((t, i) => {
      n[t] = { ...n[t] || {}, order: i };
    }), g(!0), b((t) => {
      t.columnsMap = { ...n }, t.sortKeyColumns = d;
    });
  }, Q = () => {
    P(a.columnsMap), $(a.sortKeyColumns), V === "online" && N && (M == null || M(N, a.columnsMap)), x.resolve({ ...a.columnsMap }), x.hide();
  }, B = () => {
    x.hide();
  }, v = y(() => p.colorBgContainer == "#141414", [p.colorBgContainer]);
  return /* @__PURE__ */ o.jsxs(
    L,
    {
      className: "tableColumnSettingModal",
      title: "自定义列",
      ...Y(x),
      styles: {
        body: {
          maxHeight: window.innerHeight - 300,
          "--container-bgColor": v ? "#333" : "#f6f7f9",
          "--body-bgColor": v ? "#444" : "#e0e0e0",
          "--checked": v ? "#525252" : "#eee",
          "--block-bgColor": p.colorBgContainer,
          "--colorText": p.colorText,
          "--colorText-desc": p.colorTextDescription,
          "--colorBorder": p.colorBorder
        }
      },
      width: 600,
      onCancel: B,
      footer: /* @__PURE__ */ o.jsxs(o.Fragment, { children: [
        /* @__PURE__ */ o.jsx(
          z,
          {
            type: "primary",
            icon: /* @__PURE__ */ o.jsx(xe, {}),
            onClick: Q,
            disabled: !O,
            children: "保存"
          }
        ),
        /* @__PURE__ */ o.jsx(z, { onClick: B, children: "取消" })
      ] }),
      children: [
        /* @__PURE__ */ o.jsx("div", { className: u(c.introduce, "tableColumnSetting_introduce"), children: "选择要在表中显示的可用列。拖动选定的列以对其重新排序。" }),
        /* @__PURE__ */ o.jsxs(
          "div",
          {
            className: u(c.container, "tableColumnSetting_container"),
            style: { maxHeight: window.innerHeight - 390, overflow: "auto" },
            children: [
              /* @__PURE__ */ o.jsxs("div", { className: c.block, children: [
                /* @__PURE__ */ o.jsxs("div", { className: u(c.header, "tableColumnSetting_header"), children: [
                  /* @__PURE__ */ o.jsx("div", { className: u(c.title, "tableColumnSetting_title"), children: "可用列" }),
                  /* @__PURE__ */ o.jsx("div", {})
                ] }),
                /* @__PURE__ */ o.jsx("div", { className: u(c.body, "tableColumnSetting_body"), children: /* @__PURE__ */ o.jsx("ul", { className: c.content, children: (D = w.list) == null ? void 0 : D.map((e) => {
                  const s = w.keys.includes(e.key);
                  return /* @__PURE__ */ o.jsxs(
                    "li",
                    {
                      className: u(c.item, {
                        [c.checked]: !s,
                        tableColumnSetting_checked: !s
                      }),
                      onClick: () => !e.disabled && G(s, e),
                      children: [
                        /* @__PURE__ */ o.jsx(ee, { checked: s, disabled: e.disabled }),
                        /* @__PURE__ */ o.jsx(
                          "span",
                          {
                            className: u(
                              c["content-item-text"],
                              {
                                [c["content-item-text-disabled"]]: e.disabled
                              },
                              "tableColumnSetting_content-item-text"
                            ),
                            children: e.title
                          }
                        )
                      ]
                    },
                    e.key
                  );
                }) }) })
              ] }),
              /* @__PURE__ */ o.jsxs("div", { className: c.block, children: [
                /* @__PURE__ */ o.jsxs("div", { className: c.header, children: [
                  /* @__PURE__ */ o.jsx("div", { className: c.title, children: "选定列" }),
                  /* @__PURE__ */ o.jsx(
                    oe,
                    {
                      type: "link",
                      icon: /* @__PURE__ */ o.jsx(be, {}),
                      size: "small",
                      onClick: q,
                      className: he`
                &:hover {
                  color: ${p.colorPrimary} !important;
                }
              `,
                      children: "重置"
                    }
                  )
                ] }),
                /* @__PURE__ */ o.jsx("div", { className: u(c.body, "tableColumnSetting_body-order"), children: /* @__PURE__ */ o.jsx(
                  ce,
                  {
                    modifiers: [de, ue],
                    onDragStart: (e) => {
                      const { active: s } = e;
                      s && j(s == null ? void 0 : s.id);
                    },
                    onDragCancel: () => j(null),
                    onDragEnd: (e) => {
                      j(null);
                      const { over: s } = e;
                      if (s) {
                        const n = k(s.id);
                        K !== n && J(K, n);
                      }
                    },
                    children: /* @__PURE__ */ o.jsx(
                      ae,
                      {
                        items: h == null ? void 0 : h.map((e) => e.key),
                        strategy: re,
                        children: /* @__PURE__ */ o.jsx("ul", { className: c.content, children: h == null ? void 0 : h.map((e) => /* @__PURE__ */ o.jsx(me, { item: e }, e.key)) })
                      }
                    )
                  }
                ) })
              ] })
            ]
          }
        )
      ]
    }
  );
});
export {
  Re as default
};
