import { j as e } from "../../../node_modules/react/jsx-runtime.mjs";
import { useRef as ee, useState as T, useMemo as F, useCallback as te, useEffect as re } from "react";
import { theme as se, Row as y, Col as i, Space as K, Form as h, Select as A, Spin as le, Typography as oe, Table as ce, Pagination as ne, Flex as ie, Empty as G } from "antd";
import H from "../../BitzButton/index.mjs";
import { getColumns as ae, getExpandable as pe, getLayoutConfig as ue } from "./getData.mjs";
import de from "../TextBlock/index.mjs";
import xe from "../../../node_modules/ahooks/es/useSize/index.mjs";
import "./index.less.mjs";
import he from "../../../node_modules/@ant-design/icons/es/icons/InfoCircleOutlined.mjs";
import je from "../../../node_modules/@ant-design/icons/es/icons/CloseOutlined.mjs";
function Ee({
  columns: k,
  tableData: E,
  total: J,
  loading: j,
  loadingFailed: f,
  loadAgain: O,
  page: b,
  onPageChange: I,
  searchInput: Q,
  showToolTagSelect: P,
  toolTags: W,
  onToolTagChange: g,
  lrLayout: w,
  parentRender: z,
  keys: R,
  rows: B,
  fieldNames: r,
  onChange: d,
  onDropdownVisibleChange: m
}) {
  var _;
  const C = ee(null), v = xe(C), { token: a } = se.useToken(), [o, $] = T([]), [l, q] = T([]), [L, U] = T(void 0), X = (t, s) => {
    U(t), g == null || g(t, s), t || (m(!0), setTimeout(() => {
      m(!1);
    }, 0));
  }, Y = F(() => ae(k, E, b), [k]), Z = {
    selectedRowKeys: o,
    onSelect: (t, s) => {
      if (s)
        o.push(t[r.value]), l.push(t), d(o, l);
      else {
        const p = l.filter(
          (u) => u[r.value] !== t[r.value]
        );
        d(
          p.map((u) => u[r.value]),
          p
        );
      }
    },
    onSelectAll: (t, s, p) => {
      const u = p.map((n) => n[r.value]);
      if (t) {
        const n = o.concat(u), S = l.concat(p);
        d(n, S);
      } else {
        const n = o == null ? void 0 : o.filter((x) => !u.includes(x)), S = /* @__PURE__ */ new Map();
        p.forEach((x) => {
          S.set(x[r.value], x);
        });
        const N = l == null ? void 0 : l.filter(
          (x) => !S.has(x[r.value])
        );
        d(n, N);
      }
    }
  }, D = te(() => pe(r.items), [r.items]), M = (t, s) => /* @__PURE__ */ e.jsxs("span", { style: { color: a.colorText }, children: [
    t[0],
    " ",
    /* @__PURE__ */ e.jsx("span", { style: { color: a.colorPrimary, fontWeight: 600 }, children: s }),
    " ",
    t[1]
  ] }), V = () => {
    const t = (s) => {
      const p = l.findIndex(
        (n) => n[r.value] === s[r.value]
      ), u = o.findIndex(
        (n) => n === s[r.value]
      );
      l.splice(p, 1), o.splice(u, 1), d(o, l);
    };
    return /* @__PURE__ */ e.jsxs(
      K,
      {
        direction: "vertical",
        style: {
          width: "calc(100% - 5px)",
          paddingRight: 5,
          maxHeight: l.length ? 220 : "auto",
          overflow: "hidden auto"
        },
        children: [
          l.map((s) => /* @__PURE__ */ e.jsxs(
            ie,
            {
              justify: "space-between",
              style: {
                padding: "4px 8px",
                border: `1px solid ${a.colorBorder}`,
                backgroundColor: "#f5f5f5",
                borderRadius: a.borderRadiusSM,
                overflow: "hidden"
              },
              children: [
                /* @__PURE__ */ e.jsx("div", { style: { width: "calc(100% - 15px)" }, children: /* @__PURE__ */ e.jsx(de, { value: s[r.label] }) }),
                /* @__PURE__ */ e.jsx(
                  je,
                  {
                    style: {
                      color: a.colorError,
                      fontSize: 13,
                      cursor: "pointer"
                    },
                    onClick: () => t(s)
                  }
                )
              ]
            },
            s[r.value]
          )),
          !l.length && /* @__PURE__ */ e.jsx(G, { image: G.PRESENTED_IMAGE_SIMPLE })
        ]
      }
    );
  }, c = F(() => ue(w, P), [w, P]);
  return re(() => {
    $(R ?? []), q(B ?? []);
  }, [R, B]), /* @__PURE__ */ e.jsxs(y, { gutter: c.gutter, children: [
    /* @__PURE__ */ e.jsx(i, { span: c.left.span, children: w && z && z(c.spaceSize, v == null ? void 0 : v.height) }),
    /* @__PURE__ */ e.jsx(i, { span: c.right.span, children: /* @__PURE__ */ e.jsxs(
      K,
      {
        direction: "vertical",
        size: c.spaceSize,
        style: { width: "100%" },
        children: [
          /* @__PURE__ */ e.jsx(h, { className: "tableSelectPopupSearchForm", children: /* @__PURE__ */ e.jsx(y, { gutter: [16, 16], children: /* @__PURE__ */ e.jsx(i, { span: 24, children: /* @__PURE__ */ e.jsxs(y, { justify: "space-between", gutter: [16, 16], children: [
            /* @__PURE__ */ e.jsx(i, { span: c.right.search, children: /* @__PURE__ */ e.jsx(h.Item, { children: Q }) }),
            /* @__PURE__ */ e.jsx(i, { span: c.right.operation, children: /* @__PURE__ */ e.jsxs(y, { justify: "end", gutter: 8, children: [
              /* @__PURE__ */ e.jsx(i, { span: c.right.toolTagSelect, children: /* @__PURE__ */ e.jsx(h.Item, { children: /* @__PURE__ */ e.jsx(
                A,
                {
                  allowClear: !0,
                  className: "tableSelectPopupToolTagSelect",
                  style: {
                    width: "100%",
                    "--toolTagSelect-color": j ? a.colorTextDisabled : a.colorText
                  },
                  placeholder: "常用标签",
                  showSearch: !1,
                  disabled: j,
                  options: W,
                  value: L,
                  onChange: X,
                  onDropdownVisibleChange: m
                }
              ) }) }),
              /* @__PURE__ */ e.jsx(i, { span: c.right.totalSelect, children: /* @__PURE__ */ e.jsx(h.Item, { children: /* @__PURE__ */ e.jsxs("div", { className: "tableSelectPopupTotalSelect", children: [
                /* @__PURE__ */ e.jsx(
                  A,
                  {
                    style: { width: "100%" },
                    mode: "multiple",
                    placeholder: "",
                    showSearch: !1,
                    options: l,
                    value: o,
                    fieldNames: r,
                    popupClassName: "tableSelectPopupTotalPopup",
                    dropdownRender: V,
                    tagRender: () => /* @__PURE__ */ e.jsx(e.Fragment, {}),
                    onDropdownVisibleChange: m
                  }
                ),
                /* @__PURE__ */ e.jsx("div", { className: "tableSelectPopupTotalSelectTip", children: M(
                  ["已选择", "条数据"],
                  o.length || 0
                ) })
              ] }) }) }),
              /* @__PURE__ */ e.jsx(i, { span: c.right.button, children: /* @__PURE__ */ e.jsx(
                H,
                {
                  type: "primary",
                  danger: !0,
                  onClick: () => d([], [], "clear"),
                  children: "清空"
                }
              ) }),
              /* @__PURE__ */ e.jsx(i, { span: c.right.button, children: /* @__PURE__ */ e.jsx(
                H,
                {
                  type: "primary",
                  onClick: () => d([], [], "confirm"),
                  children: "确认"
                }
              ) })
            ] }) })
          ] }) }) }) }),
          /* @__PURE__ */ e.jsx(
            "div",
            {
              ref: C,
              ...f && {
                className: "pointerMouse",
                onClick: () => O()
              },
              children: /* @__PURE__ */ e.jsx(
                le,
                {
                  spinning: f,
                  indicator: /* @__PURE__ */ e.jsx(he, {}),
                  tip: /* @__PURE__ */ e.jsx(oe.Text, { type: "danger", children: "加载失败，点击重试" }),
                  children: /* @__PURE__ */ e.jsx(
                    ce,
                    {
                      rowKey: r.value,
                      loading: j,
                      bordered: !0,
                      sticky: !0,
                      size: "small",
                      scroll: { y: 400 },
                      pagination: !1,
                      rowSelection: Z,
                      columns: Y,
                      dataSource: E,
                      ...f && { className: "loadingFailedTable" },
                      ...D(),
                      style: {
                        "--tableBody-bootomBorderColor": (_ = a.Table) == null ? void 0 : _.borderColor
                      }
                    }
                  )
                }
              )
            }
          ),
          /* @__PURE__ */ e.jsx(h, { children: /* @__PURE__ */ e.jsx(h.Item, { style: { marginBottom: 0 }, children: /* @__PURE__ */ e.jsx(
            ne,
            {
              disabled: j,
              className: "tableSelectPopupTablePagination",
              size: "small",
              current: b.pageIndex,
              pageSize: b.pageSize,
              showTotal: (t) => M(["共", "条"], t),
              showSizeChanger: !0,
              showQuickJumper: !0,
              total: J,
              onChange: I,
              onShowSizeChange: (t, s) => I(1, s)
            }
          ) }) })
        ]
      }
    ) })
  ] });
}
export {
  Ee as default
};
