import { FC } from "react";
import { type SkeletonProps } from "antd";
import { SkeletonButtonProps } from "antd/es/skeleton/Button";
import { AvatarProps } from "antd/es/skeleton/Avatar";
import { SkeletonInputProps } from "antd/es/skeleton/Input";
import { SkeletonImageProps } from "antd/es/skeleton/Image";
import { SkeletonNodeProps } from "antd/es/skeleton/Node";
type CompoundedComponent = {
    Button: typeof SkeletonButton;
    Avatar: typeof SkeletonAvatar;
    Input: typeof SkeletonInput;
    Image: typeof SkeletonImage;
    Node: typeof SkeletonNode;
};
export interface BitzSkeletonProps extends SkeletonProps {
}
declare const BitzSkeleton: FC<BitzSkeletonProps> & CompoundedComponent;
export interface BitzSkeletonButtonProps extends SkeletonButtonProps {
}
declare const SkeletonButton: FC<BitzSkeletonButtonProps>;
interface BitzSkeletonAvatarProps extends AvatarProps {
}
declare const SkeletonAvatar: FC<BitzSkeletonAvatarProps>;
interface BitzSkeletonInputProps extends SkeletonInputProps {
}
declare const SkeletonInput: FC<BitzSkeletonInputProps>;
interface BitzSkeletonImageProps extends SkeletonImageProps {
}
declare const SkeletonImage: FC<BitzSkeletonImageProps>;
interface BitzSkeletonNodeProps extends SkeletonNodeProps {
}
declare const SkeletonNode: FC<BitzSkeletonNodeProps>;
export default BitzSkeleton;
