/// <reference types="react" />
import { BitzSelectionBarProps } from './SelectionBar';
import { BitzSelectionBarButton, BitzSelectionBarDropdownButton } from './Button';
type CompoundedComponent = React.ForwardRefExoticComponent<BitzSelectionBarProps> & {
    Button: typeof BitzSelectionBarButton;
    DropdownButton: typeof BitzSelectionBarDropdownButton;
};
declare const BitzSelectionBar: CompoundedComponent;
export default BitzSelectionBar;
