import { ReactNode } from 'react';
import { BitzDropdownToButtonProps } from '@/components/BitzConvert';
import { ExportEvent } from '..';
interface ExportIconProps extends Pick<BitzDropdownToButtonProps, 'menu' | 'tipText'> {
    icon?: ReactNode;
    loading?: boolean;
    /** 是否显示导出icon */
    show?: boolean;
    /**
     * 导出按钮下拉菜单的点击事件，通过key值判断是导出为excel或其他格式的文件
     * @Key1 导出查询结果为excel: excel
     */
    onClick?: ExportEvent;
}
declare const _default: import("react").NamedExoticComponent<ExportIconProps>;
export default _default;
