import defaultAlgorithm from 'antd/es/theme/themes/default';
import { BitzAliasToken, BitzComponentTokenMap } from '../BitzConfigProvider';
export type BitzGlobalToken = BitzAliasToken & BitzComponentTokenMap;
declare function useToken(): {
    theme: import("@ant-design/cssinjs").Theme<import("antd/es/theme/internal").SeedToken, import("antd/es/theme/interface").MapToken>;
    token: BitzGlobalToken;
    hashId: string;
};
declare const _default: {
    /** Default seedToken */
    defaultSeed: import("antd/es/theme/internal").SeedToken;
    useToken: typeof useToken;
    defaultAlgorithm: typeof defaultAlgorithm;
    darkAlgorithm: import("@ant-design/cssinjs").DerivativeFunc<import("antd/es/theme/internal").SeedToken, import("antd/es/theme/interface").MapToken>;
    compactAlgorithm: import("@ant-design/cssinjs").DerivativeFunc<import("antd/es/theme/internal").SeedToken, import("antd/es/theme/interface").MapToken>;
    getDesignToken: (config?: import("antd").ThemeConfig | undefined) => import("antd/es/theme/internal").AliasToken;
};
export default _default;
