import { RowSelectionType, TableRowSelection } from 'antd/es/table/interface';
import { Key } from 'react';
interface UseRowSelectionReturnType<T = any> {
    type: RowSelectionType;
    selectedRowKeys: Key[];
    clean: () => void;
    onSelect?: TableRowSelection<T>['onSelect'];
    onSelectAll?: TableRowSelection<T>['onSelectAll'];
    onChange?: TableRowSelection<T>['onChange'];
}
/** 处理table跨页多选的hook */
declare const useRowSelection: (rowKey?: string, type?: RowSelectionType) => UseRowSelectionReturnType;
export default useRowSelection;
