const r = {
  /**
   *
   * @param key 存储对应的参数名
   * @param value 存储对应的参数值
   */
  setItem(e, t) {
    t = JSON.stringify(t), window.localStorage.setItem(e, t);
  },
  /**
   *
   * @param key 获取存储的参数名
   * @param defaultValue
   * @returns
   */
  getItem(e, t) {
    let o = window.localStorage.getItem(e);
    return o ? (o = JSON.parse(o), o) : t;
  },
  /**
   *
   * @param key 删除指定数据名
   */
  removeItem(e) {
    window.localStorage.removeItem(e);
  },
  /**
   * @description 清空所有存储
   */
  clear() {
    window.localStorage.clear();
  }
};
export {
  r as default
};
