import { j as r } from "../../../node_modules/react/jsx-runtime.mjs";
import { useContext as ve, useState as F, useMemo as g, useRef as L, useCallback as J, useEffect as Ne } from "react";
import { isMobile as W } from "../../../node_modules/react-device-detect/dist/lib.mjs";
import { Table as H, Skeleton as Me } from "antd";
import ke from "../../../node_modules/classnames/index.mjs";
import ze from "../../BitzDrawer/index.mjs";
import Le from "../../BitzPagination/index.mjs";
import We from "../../BitzNoData/index.mjs";
import "../../BitzList/index.less.mjs";
import He from "../../BitzList/List.mjs";
import "../../BitzPullRefresh/style/index.less.mjs";
import Se from "../../BitzPullRefresh/PullRefresh.mjs";
import Pe, { TableContext as Ae } from "../Store/index.mjs";
import Re from "../TableSkeleton/index.mjs";
import { columnSort as Q, genColumnKey as Y } from "../Store/utils/index.mjs";
import S from "../../../node_modules/ahooks/es/useSize/index.mjs";
import Ee from "../ActionCol/style.mjs";
import Oe from "../../BitzTheme/index.mjs";
import "./index.less.mjs";
import Ve from "../../../node_modules/lodash-es/at.mjs";
function Ke({
  showPagination: w = !0,
  fillEvenRow: P = !0,
  evenRowBgColor: _e = "#f9f9f9",
  height: p,
  dataSource: a = [],
  total: N = 0,
  columns: u,
  loading: B = !1,
  skeletonNum: Z = 2,
  skeletonRender: A,
  skeletonRowNum: I = 4,
  skeletonRowsWidth: ee = ["35%", "100%", "100%", "60%"],
  mobileLoadEmit: oe,
  mobileRefreshEmit: R,
  operationFilter: M,
  enableControlPage: re,
  pagination: te,
  paginationEmit: ne = () => {
  },
  mobilePageHeight: $e = 500,
  mobileCancelText: le = "取消",
  noDataTitle: se,
  noDataImg: ae,
  color: De,
  size: E,
  showTableTool: ie = !0,
  tableAction: ce,
  tableToolbar: de,
  selectionBar: he,
  scroll: d,
  resetPage: fe,
  ...h
}) {
  var U;
  const { token: c } = Oe.useToken(), { gap: be } = Ee(), f = ve(Ae), [xe, k] = F(!1), ge = g(() => !!(a != null && a.length) && (a == null ? void 0 : a.length) >= N, [a, N]), [ue, ye] = F([]), Ce = (e, o) => {
    var t;
    const n = (t = M == null ? void 0 : M(e, o)) == null ? void 0 : t.filter(
      (l) => l.type !== "divider"
    );
    n != null && n.length && (ye(n), k(!0));
  }, O = () => {
    k(!1);
  }, pe = (e) => {
    var o;
    k(!1), (o = e.onClick) == null || o.call(e);
  }, y = L(null);
  S(y);
  const j = L(null);
  S(j);
  const V = L(null), C = S(V), me = () => {
    var n;
    const e = (n = j.current) == null ? void 0 : n.querySelectorAll(
      ".ant-table-body tr:not(.ant-table-measure-row)"
    ), o = [];
    if (e == null || e.forEach((t) => {
      var l;
      o.push(
        ((l = t.querySelector(".operationCol .actionGroup")) == null ? void 0 : l.clientWidth) || 0
      );
    }), o.length)
      return Math.ceil(Math.max(...o)) + be * 2;
  }, K = () => {
    var l;
    const e = (l = j.current) == null ? void 0 : l.querySelector(
      ".ant-table-body"
    ), o = e == null ? void 0 : e.clientWidth, n = ((e == null ? void 0 : e.offsetWidth) || 0) - o, t = n > 0;
    return { tbodyWidth: o, scrollBarWidth: n, hasScrollBar: t };
  }, { y: z, hasScrollBar: _ } = g(() => {
    if (typeof p > "u")
      return {};
    const { hasScrollBar: e } = K();
    let o = 40, n = 40, t = 10;
    if (y.current) {
      const b = window.getComputedStyle(y.current);
      o = parseInt(b.getPropertyValue("--cell-block")), n = parseInt(b.getPropertyValue("--toolbar-height")), t = parseInt(b.getPropertyValue("--container-gap")) || 0;
    }
    const l = (C == null ? void 0 : C.height) || 0, s = l ? t : 0;
    return { y: p - l - s - n - o, hasScrollBar: e };
  }, [p, C == null ? void 0 : C.height]), T = g(() => d != null && d.x ? { x: d.x, y: d.y || z } : d != null && d.y ? { x: 1e3, y: d.y } : { x: 1e3, y: z }, [d, z]), $ = J(
    (e) => {
      const o = e.length, n = e.filter((x) => x.width), l = n.map((x) => x.width).reduce((x, Te) => x + Te, 0);
      let s = 0;
      if (y.current) {
        const x = window.getComputedStyle(y.current);
        s = parseInt(x.getPropertyValue("--toolCell-width"));
      }
      let i = 0;
      h.rowSelection && (i += s), h.expandable && (i += s);
      const { tbodyWidth: v } = K(), b = parseInt(`${T.x}`) || 0, je = Math.max(b, v), X = (parseInt(`${je}`) || 0) - l - i;
      return X >= 0 ? X / (o - n.length) : void 0;
    },
    [h.expandable, h.rowSelection, T]
  ), m = g(() => {
    const e = (s) => s.map((i) => {
      const v = Y(
        (i == null ? void 0 : i.key) || (i == null ? void 0 : i.dataIndex),
        i.index
      ), b = f.columnsMap[v];
      return b && b.show === !1 ? !1 : i.children ? {
        ...i,
        children: e(i.children)
      } : i;
    }).filter(Boolean), o = e(u);
    if (W)
      return o.sort(Q(f.columnsMap));
    const n = o.sort(Q(f.columnsMap)), t = $(n), l = n.map((s) => ({
      ...s,
      ...s.width ? {
        width: s.useMaxWidth ? me() ?? s.width : s.width
      } : {
        // 给未设置width的列设置平均数
        width: t
      }
    }));
    return [H.SELECTION_COLUMN, H.EXPAND_COLUMN, ...l];
  }, [u, f.columnsMap, $, f.sortKeyColumns]);
  Ne(() => {
    if (u && u.length > 0) {
      const e = u.map(
        (o) => (
          // @ts-ignore
          Y((o == null ? void 0 : o.key) ?? (o == null ? void 0 : o.dataIndex), o == null ? void 0 : o.dataIndex)
        )
      );
      f.setSortKeyColumns(e);
    }
  }, [u]);
  const D = g(() => `${E ?? (f == null ? void 0 : f.tableSize) ?? "lg"}BitzTable`, [E, f.tableSize]), we = g(() => ke(
    "bitzTableContainer",
    /* "hideBorder", */
    { hasScrollBar: _ },
    D
  ), [D, _]), Be = g(() => {
    var e, o, n, t, l, s;
    return {
      height: p,
      "--toolbar-bgColor": (e = c.Table) == null ? void 0 : e.toolbarBgColor,
      "--thead-bgColor": (o = c.Table) == null ? void 0 : o.headerBg,
      "--thead-hoverBgColor": (n = c.Table) == null ? void 0 : n.headerSortHoverBg,
      "--evenRow-BgColor": (t = c.Table) == null ? void 0 : t.evenRowBgColor,
      "--expandIcon-borderColor": (l = c.Table) == null ? void 0 : l.expandIconBorderColor,
      "--rowHover-bgColor": (s = c.Table) == null ? void 0 : s.rowHoverBg
      // '--tableBody-bootomBorderColor': token.Table?.borderColor || '#f0f0f0',
    };
  }, [p, c.Table]), q = J(
    (e, o) => P ? o % 2 === 0 ? "oddRow" : "evenRow" : "",
    [P]
  ), G = /* @__PURE__ */ r.jsx(
    He,
    {
      finished: ge,
      onLoad: oe,
      loadingText: "加载中...",
      finishedText: "没有更多了",
      errorText: "加载失败",
      children: /* @__PURE__ */ r.jsxs(
        "div",
        {
          className: "mobileList",
          style: { backgroundColor: (U = c.Table) == null ? void 0 : U.mobileListBgColor },
          children: [
            a == null ? void 0 : a.map((e, o) => {
              var n;
              return /* @__PURE__ */ r.jsx(
                "div",
                {
                  className: "listItem",
                  style: { backgroundColor: (n = c.Table) == null ? void 0 : n.listItemBgColor },
                  onClick: () => Ce(e, o),
                  children: m == null ? void 0 : m.map((t, l) => {
                    var s;
                    return !(t != null && t.mobileHide) && /* @__PURE__ */ r.jsxs(
                      "div",
                      {
                        className: "row",
                        style: { color: c.colorText },
                        children: [
                          !t.mobileHideLabel && /* @__PURE__ */ r.jsxs("div", { className: "label", children: [
                            `${t.title}`,
                            "："
                          ] }),
                          /* @__PURE__ */ r.jsx("div", { className: "value", children: ((s = t == null ? void 0 : t.render) == null ? void 0 : s.call(
                            t,
                            Ve(e, (t == null ? void 0 : t.dataIndex) || ""),
                            e,
                            o
                          )) || (e == null ? void 0 : e[t.dataIndex]) })
                        ]
                      },
                      l
                    );
                  })
                },
                o
              );
            }),
            B && Array.from({ length: Z }).map((e, o) => {
              var n;
              return /* @__PURE__ */ r.jsx(
                "div",
                {
                  className: "listItem",
                  style: { backgroundColor: (n = c.Table) == null ? void 0 : n.listItemBgColor },
                  children: /* @__PURE__ */ r.jsx("div", { className: "row", children: A ? A() : /* @__PURE__ */ r.jsx(
                    Me,
                    {
                      title: !1,
                      paragraph: {
                        rows: I,
                        width: ee
                      },
                      active: !0
                    }
                  ) })
                },
                o
              );
            })
          ]
        }
      )
    }
  );
  return /* @__PURE__ */ r.jsxs("div", { className: "bitzTableBlock", children: [
    !W && /* @__PURE__ */ r.jsxs("div", { ref: y, className: we, style: Be, children: [
      /* @__PURE__ */ r.jsxs("div", { className: "bitzTableContainerBody", ref: j, children: [
        ie && /* @__PURE__ */ r.jsxs("div", { className: "bitzTableToolbarBlock", children: [
          ce || /* @__PURE__ */ r.jsx("div", {}),
          de,
          (h == null ? void 0 : h.rowSelection) && /* @__PURE__ */ r.jsx(r.Fragment, { children: he })
        ] }),
        /* @__PURE__ */ r.jsx(
          H,
          {
            columns: m,
            dataSource: a,
            loading: !1,
            pagination: !1,
            scroll: T,
            ...h,
            rowClassName: q
          }
        ),
        /* @__PURE__ */ r.jsx(
          Re,
          {
            columns: m,
            dataLength: a.length,
            scroll: T,
            rowSelection: h.rowSelection,
            expandable: h.expandable,
            rowClassName: q,
            loading: B
          }
        )
      ] }),
      w && /* @__PURE__ */ r.jsx(
        Le,
        {
          elRefInstance: V,
          enableControl: re,
          pagination: te,
          total: N,
          dataSource: a,
          resetPage: fe,
          paginationEmit: ne
        }
      )
    ] }),
    W && /* @__PURE__ */ r.jsxs(r.Fragment, { children: [
      (B || (a == null ? void 0 : a.length) > 0) && /* @__PURE__ */ r.jsx(r.Fragment, { children: R ? /* @__PURE__ */ r.jsx(Se, { onRefresh: R, children: G }) : G }),
      !B && /* @__PURE__ */ r.jsx(We, { data: a, title: se, img: ae }),
      /* @__PURE__ */ r.jsx(
        ze,
        {
          className: "tableMobileDrawer",
          open: xe,
          placement: "bottom",
          height: "auto",
          closable: !1,
          onClose: O,
          children: /* @__PURE__ */ r.jsxs("div", { className: "drawerBox", children: [
            /* @__PURE__ */ r.jsx("div", { className: "boxBody", children: ue.map((e, o) => /* @__PURE__ */ r.jsx(
              "div",
              {
                className: "operaList",
                onClick: () => pe(e),
                ...e.danger && {
                  style: { color: c.colorError }
                },
                children: e.label
              },
              o
            )) }),
            /* @__PURE__ */ r.jsx("div", { className: "boxLine" }),
            /* @__PURE__ */ r.jsx("div", { className: "boxFooter", onClick: O, children: le })
          ] })
        }
      )
    ] })
  ] });
}
const ho = (w) => (
  // @ts-ignore
  /* @__PURE__ */ r.jsx(Pe, { initValue: w, children: /* @__PURE__ */ r.jsx(Ke, { ...w }) })
);
export {
  ho as default
};
