declare const BitzLocalStorage: {
    /**
     *
     * @param key 存储对应的参数名
     * @param value 存储对应的参数值
     */
    setItem(key: string, value: string): void;
    /**
     *
     * @param key 获取存储的参数名
     * @param defaultValue
     * @returns
     */
    getItem(key: string, defaultValue?: undefined): string | null | undefined;
    /**
     *
     * @param key 删除指定数据名
     */
    removeItem(key: string): void;
    /**
     * @description 清空所有存储
     */
    clear(): void;
};
export default BitzLocalStorage;
