import { FC } from 'react';
import './index.less';
interface TextBlockProps {
    /** 文本显示的最小行数 */
    minRows?: number;
    /** 文本显示的最大行数，超出设置行数的文本会显示省略号 */
    maxRows?: number;
    /** 文本是否加粗 */
    bold?: number;
    /** 文本内容 */
    value?: string;
    /** 类名 */
    className?: string;
}
declare const TextBlock: FC<TextBlockProps>;
export default TextBlock;
